unit frmMain;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Rtti, System.Classes,
  System.Variants, FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Objects;

type
  TForm1 = class(TForm)
    Image1: TImage;
    btnStart: TButton;
    Label1: TLabel;
    Label2: TLabel;
    StyleBook2: TStyleBook;
    procedure btnStartClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image1Paint(Sender: TObject; Canvas: TCanvas;
      const ARect: TRectF);
    procedure FormDestroy(Sender: TObject);
  private
    { private 錾 }
  public
    { public 錾 }
    FBmp: TBitmap;
  end;

var
  Form1: TForm1;

implementation

{$R *.fmx}

const
  BMP_WIDTH = 640;
  BMP_HEIGHT = 480;

type
  PDWordArray = ^TDWordArray;
  TDWordArray = array [0 .. 1] of DWORD;

procedure TForm1.btnStartClick(Sender: TObject);
var
  X, Y, n: Integer;
  YAddr: Integer;
  BmpData: TBitmapData;
  c1, c2, C3: TDateTime;
begin

  c1 := GetTIme;
  Caption := IntToStr(BmpData.Pitch);
  for n := 1 to 100 do
  begin
    FBmp.Map(TMapAccess.maWrite, BmpData);
    for Y := 0 to FBmp.Height - 1 do
    begin
      YAddr := Y * FBmp.Height;
      for X := 0 to FBmp.Width - 1 do
      begin
        PAlphaColorArray(BmpData.Data)^[YAddr + X] := $80FF0000;
      end;
    end;
    FBmp.Unmap(BmpData);
  end;
  Label1.Text := FormatDateTime('hh:nn:ss zzz', c1) + '  ' +
    FormatDateTime('hh:nn:ss zzz', GetTIme);

  c2 := GetTIme;
  FBmp.Map(TMapAccess.maWrite, BmpData);
  for n := 1 to 100 do
  begin
    // Self.Canvas.BeginScene; // V[bN
    for Y := 0 to FBmp.Height - 1 do
      for X := 0 to FBmp.Width - 1 do
        BmpData.SetPixel(X, Y, $80FF0000);
  end;
  FBmp.Unmap(BmpData);
  Label2.Text := FormatDateTime('hh:nn:ss zzz', c2) + '  ' +
    FormatDateTime('hh:nn:ss zzz', GetTIme);

  Image1.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FBmp := TBitmap.Create(BMP_WIDTH, BMP_HEIGHT);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FBmp.Free;
end;

procedure TForm1.Image1Paint(Sender: TObject; Canvas: TCanvas;
  const ARect: TRectF);
begin
  Image1.Canvas.DrawBitmap(FBmp, RectF(0, 0, 640, 480),
    RectF(0, 0, 640, 480), 1);
end;

end.
